/*
 * FlightForm 1.0 by marrvin
 *
 * This Plugin cancels druid ground travel form in areas where flight form could be used instead.
 * Currently (HB 878) Flightor will cast travel form to "fly". When in combat this fails and falls back to ground travel form.
 * Unfortunatley Flightor and/or the Botbase "assumes" the char is flying  resulting in endless stucks at obstacles / walls
 * and also preventing it from fighting back !
 *
 * To reduce preformance impact this check will only be done every 5 seconds
 * 
 */
 
using System;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Common.Helpers;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace FlightForm
{
    public class FlightForm : Styx.Plugins.HBPlugin
    {
        public override string Name { get { return "FlightForm"; } }
        public override string Author { get { return "marrvin"; } }
        public override Version Version { get { return new Version(1, 0); } }
		private static LocalPlayer Me { get { return StyxWoW.Me; } }
		
		private readonly WaitTimer _updateTimer = WaitTimer.FiveSeconds;
		private readonly Color DruidColor = Color.FromRgb(255,	125, 10);     // Druid Class Color  :D  #FF7D0A 

        public override void Pulse()
		{
			if (_updateTimer.IsFinished)
            {
                _updateTimer.Reset();
				
				if (Me.IsFlying || (Me.Class != WoWClass.Druid) || Me.IsDead || Me.IsGhost || Me.OnTaxi  || Me.IsOnTransport  || !Flightor.CanFly) return;
					
				// Logging.Write(DruidColor, "[Flightform] check for ground travel form!");	 // debug
				
				if (!Me.HasAura(165961))	return;  
				
				Logging.Write(DruidColor, "[Flightform] ground travel form aura on me!");
					
				if (Me.Combat)
				{
					Logging.Write(DruidColor, "[Flightform] not flying and in combat: casting cat form!");	
					SpellManager.Cast(768); 
				}
				else
				{
					Logging.Write(DruidColor, "[Flightform] not flying: cancel ground travel");			
					Lua.DoString("RunMacroText(\"/cancelform\")");
					// yes!  you actually can fallback into flight-travel form  after cancelling ground travel from
					// seems like a bug on Blizzards side to me. 
					// I let the botbase decide to switch into travel form 
				} 
			}
		}
    }
}
